#include <kdebug.h>

#include <qimage.h>
#include <qiodevice.h>

#include "wbz.h"

QIODevice *wsFile;
int ENCRYPT_P[] = {'W','W','B','B',0};

int search(unsigned int from, unsigned int to, int str[])
{
  wsFile->at(from);
  while(wsFile->at() < to)
  {
    int i = 0;
    while(str[i] != 0)
    {
      if( wsFile->getch() != str[i++]){
        goto next;
      }
    }
    
    return wsFile->at();
    
    next:
      continue;
  }
  return 0;
}

QByteArray decriptImage()
{ 
  QIODevice::Offset start;
  QIODevice::Offset size;
  int type;
  
  QIODevice::Offset end = wsFile->size();
  start = search(0, end, ENCRYPT_P);
  size = end - start + 4;
  wsFile->at(start + 1);
  wsFile->getch();
  type = wsFile->getch() - 0x30;
  
  wsFile->at(start + 4);
    
  QByteArray theImage(size);
  
  char * enc = theImage.data();
  
  wsFile->readBlock(enc, size);
  
  int magic;
  switch(type)
  {
    case 0:  // JPEG WB0 Encrypted
      magic = 0xA4;
      break;
    case 1:  // JPEG WB1 Encrypted
      magic = 0xF2;
      break;
  }
  
  // decrypt algoritm
  char A[100];
  char B[100];
  int i;
  wsFile->at(start + 4);
  
  for(i = 0; i < 100; i++)
    A[i] = wsFile->getch();
  
  for(i = 0; i < 100; i++)
    B[i] = wsFile->getch();
  
  for(i = 0; i < 100; i++)
  {
    B[i] = (A[i] ^ (~B[i]));
    B[i] ^= magic;
  }
     
  for(i = 0 ; i < 100; i++)
  {
    enc[i] = B[i];
  }
  
  return theImage;
}

extern "C" void kimgio_wbz_read( QImageIO* io )
{
  kdDebug() << "Reading wbz ..." << endl;
//  QImage image;
//  image.create(100,100,1);
  wsFile = io->ioDevice();
  QImage image(decriptImage());
  io->setImage(image);
  io->setStatus(0);
}

extern "C" void kimgio_wbz_write( QImageIO* io )
{
}