/***************************************************************************
 *   Copyright (C) 2004 by Stefano Salvador                                *
 *   salva_ste@tin.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _webshots_H_
#define _webshots_H_

#include <qstring.h>
#include <qstringlist.h>
#include <qcstring.h>
#include <qfile.h>

#include <kurl.h>
#include <kio/global.h>
#include <kio/slavebase.h>
#include <sys/types.h>

class QCString;

class infoImg
{
public:
  int index;
  QIODevice::Offset address;
  QString title;
  QString author;
  QIODevice::Offset start;
  QIODevice::Offset end;
  QIODevice::Offset size;
  int type;
  bool isValid;
    
  infoImg(int idx = 0, int pos = 0)
  {
    index = idx;
    address = pos;
    start = 0;
    end = 0;
    size = 0;
    isValid = true;
  }
};

class kio_webshotsProtocol : public KIO::SlaveBase
{
public:
  kio_webshotsProtocol(const QCString &pool_socket, const QCString &app_socket);
  virtual ~kio_webshotsProtocol();
  virtual void mimetype(const KURL& url);
  virtual void get(const KURL& url);
  virtual void stat( const KURL & url );
  virtual void listDir( const KURL & url );

private:
  bool isCollection();
  bool checkNewFile( const KURL & url, QString & path );
  QString getSectionName();
  void getImagesList();
  QByteArray getImage(QString fileName);
  int search(unsigned int from, unsigned int to, int str[]);
    
  QValueList<infoImg> *m_infoList;
  QFile *m_wsFile;
  QString m_wsName;
  time_t m_mtime;
  
  QString m_owner;
  QString m_group;
};

#endif
